// NFC.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "NFC.h"

#include <afxdllx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void nfc_unload_bitmap(CBitmap & o_Bitmap)
{
	if(o_Bitmap.GetSafeHandle() != NULL)
	{
		VERIFY(o_Bitmap.DeleteObject());
	}
}

BOOL nfc_load_bitmap(LPCTSTR i_FileName, CBitmap & o_Bitmap)
{
	nfc_unload_bitmap(o_Bitmap);

	ASSERT(i_FileName);

	HBITMAP hBitmap = (HBITMAP) ::LoadImage(NULL, i_FileName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | /*LR_CREATEDIBSECTION |*/ LR_DEFAULTSIZE);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	VERIFY(o_Bitmap.Attach(hBitmap));

	return TRUE;
}

void nfc_capture_background(CWnd * i_pControl, CDC & o_CaptureDC, CRect & o_Rect)
{
	NFTRACE_USED("nfc_capture_background");

	i_pControl->GetClientRect(o_Rect); // client coordinates

	CRect Rect;
	i_pControl->GetWindowRect(Rect); // screen coordinates relative to the upper-left corner of the display screen
	i_pControl->GetParent()->ScreenToClient(Rect); // The new coordinates are relative to the upper-left corner of the CWnd client area
	
	ASSERT(i_pControl->GetParent());

	CClientDC ClientDC(i_pControl->GetParent());

	//ASSERT(o_CaptureDC.GetSafeHdc() == NULL);
	if(o_CaptureDC.GetSafeHdc() != NULL)
	{
		VERIFY(o_CaptureDC.DeleteDC());
	}

	//VERIFY(m_CaptureDC.DeleteDC());
	
	// DC 
	VERIFY(o_CaptureDC.CreateCompatibleDC(&ClientDC));

	CBitmap CaptureBitmap;
	
	// Ʈ 
	VERIFY(CaptureBitmap.CreateCompatibleBitmap(&ClientDC, o_Rect.Width(), o_Rect.Height()));
	// DC Ʈ Select  ְ
	o_CaptureDC.SelectObject(CaptureBitmap);
	// ̴ ִ ġ θ Ʈ ͼ 
	o_CaptureDC.BitBlt(0, 0, o_Rect.Width(), o_Rect.Height(), &ClientDC, Rect.left, Rect.top, SRCCOPY);
}

BOOL nfcLoadBitmap(LPCTSTR i_FileName, CBitmap & o_Bitmap, CSize & o_BitmapSize)
{
	if(::nfc_load_bitmap(i_FileName, o_Bitmap))
	{
		BITMAP Bitmap;
		o_Bitmap.GetBitmap(&Bitmap);
		o_BitmapSize = CSize(Bitmap.bmWidth, Bitmap.bmHeight);

		return TRUE;
	}

	return FALSE;
}

/*
void nfcDialogSetBitmap(LPCTSTR i_FileName)
{
}
*/

/*
void nfcCaptureBackground(CWnd * i_pControl, CBitmap & o_Bitmap, CRect & o_Rect)
{
	i_pControl->GetClientRect(o_Rect); // client coordinates

	CRect Rect;
	i_pControl->GetWindowRect(Rect); // screen coordinates relative to the upper-left corner of the display screen
	i_pControl->GetParent()->ScreenToClient(Rect); // The new coordinates are relative to the upper-left corner of the CWnd client area
	
	ASSERT(i_pControl->GetParent());

	CClientDC ClientDC(i_pControl->GetParent());

	CBitmap ClientBitmap;
	CDC CaptureDC;

	// DC 
	VERIFY(CaptureDC.CreateCompatibleDC(&ClientDC));
	
	// Ʈ 
	VERIFY(ClientBitmap.CreateCompatibleBitmap(&ClientDC, o_Rect.Width(), o_Rect.Height()));

	// DC Ʈ Select  ְ
	CaptureDC.SelectObject(ClientBitmap);
	CaptureDC.BitBlt(0, 0, o_Rect.Width(), o_Rect.Height(), &ClientDC, Rect.left, Rect.top, SRCCOPY);

	ASSERT(o_Bitmap.GetSafeHandle() == NULL);
	o_Bitmap.CreateCompatibleBitmap(&CaptureDC, o_Rect.Width(), o_Rect.Height());

	CaptureDC.DeleteDC();
}
*/

static AFX_EXTENSION_MODULE NFCDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("NFC.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(NFCDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(NFCDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("NFC.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(NFCDLL);
	}
	return 1;   // ok
}
