// NFCButton.cpp : implementation file
//

#include "stdafx.h"
//#include "	\ add additional includes here"
#include "NFCButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL nfc_load_bitmap(LPCTSTR i_FileName, CBitmap & o_Bitmap);
void nfc_unload_bitmap(CBitmap & o_Bitmap);

/////////////////////////////////////////////////////////////////////////////
// NFCButton

NFCButton::NFCButton()
{
	m_State = NFC_BUTTON_STATE_AUTO;
}

NFCButton::~NFCButton()
{
	this->UnloadBitmap();
}


BEGIN_MESSAGE_MAP(NFCButton, CButton)
	//{{AFX_MSG_MAP(NFCButton)
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_WM_ENABLE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NFCButton message handlers

void NFCButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	// TODO: Add your code to draw the specified item
	CBitmap * pBitmap;
	BOOL bIsPressed  = (lpDrawItemStruct->itemState & ODS_SELECTED);
//	BOOL bIsFocused  = (lpDrawItemStruct->itemState & ODS_FOCUS);
//	BOOL bIsDisabled = (lpDrawItemStruct->itemState & ODS_DISABLED);

	switch(m_State)
	{
	case NFC_BUTTON_STATE_AUTO:
		if(bIsPressed)
		{
			pBitmap = &m_BitmapDown;
		}
		else
		{
			pBitmap = &m_BitmapUp;
		}
		break;
	case NFC_BUTTON_STATE_UP:
		pBitmap = &m_BitmapUp;
		break;
	case NFC_BUTTON_STATE_DOWN:
		pBitmap = &m_BitmapDown;
		break;
	default:
		ASSERT(FALSE);
	}

	if(pBitmap->GetSafeHandle())
	{
		CDC *pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
		CDC MemoryDC;
		CSize BitmapSize = pBitmap->GetBitmapDimension();

		MemoryDC.CreateCompatibleDC(pDC);
		MemoryDC.SelectObject(pBitmap);

		pDC->BitBlt(0, 0, BitmapSize.cx, BitmapSize.cy, &MemoryDC, 0, 0, SRCCOPY);

		//pDC->DeleteDC(); // DeleteDC CreateDC  DC ؼ
		MemoryDC.DeleteDC();

		this->SetWindowPos(NULL, 0, 0, BitmapSize.cx, BitmapSize.cy, SWP_NOMOVE | SWP_NOZORDER);
	}
	else	// Ʈ   Default ൿ, MSDN DrawItem Example 
	{
		UINT uStyle = DFCS_BUTTONPUSH;

		// This code only works with buttons.
		ASSERT(lpDrawItemStruct->CtlType == ODT_BUTTON);

		// If drawing selected, add the pushed style to DrawFrameControl.
		if(pBitmap == &m_BitmapDown)
		{
			uStyle |= DFCS_PUSHED;
		}

		// Draw the button frame.
		VERIFY(::DrawFrameControl(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, DFC_BUTTON, uStyle));

		// Get the button's text.
		CString strText;
		GetWindowText(strText);

		// Draw the button text using the text color red.
		//COLORREF crOldColor = ::SetTextColor(lpDrawItemStruct->hDC, RGB(0,0,0));
		::DrawText(lpDrawItemStruct->hDC, strText, strText.GetLength(), &lpDrawItemStruct->rcItem, DT_SINGLELINE|DT_VCENTER|DT_CENTER);
		//::SetTextColor(lpDrawItemStruct->hDC, crOldColor);
	}
}

BOOL NFCButton::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return FALSE;
	//return CButton::OnEraseBkgnd(pDC);
}

void NFCButton::SetState(enum NFC_BUTTON_STATE i_State)
{
	m_State = i_State;
	this->Invalidate();
}

void NFCButton::LoadBitmapDown(LPCTSTR i_FileName)
{
	if(nfc_load_bitmap(i_FileName, m_BitmapDown))
	{
		BITMAP Bitmap;
		m_BitmapDown.GetBitmap(&Bitmap);
		m_BitmapDown.SetBitmapDimension(Bitmap.bmWidth, Bitmap.bmHeight);
	}
}

void NFCButton::LoadBitmapUp(LPCTSTR i_FileName)
{
	if(nfc_load_bitmap(i_FileName, m_BitmapUp))
	{
		BITMAP Bitmap;
		m_BitmapUp.GetBitmap(&Bitmap);
		m_BitmapUp.SetBitmapDimension(Bitmap.bmWidth, Bitmap.bmHeight);
	}
}

void NFCButton::UnloadBitmap()
{
	nfc_unload_bitmap(m_BitmapUp);
	nfc_unload_bitmap(m_BitmapDown);
}

void NFCButton::OnSize(UINT nType, int cx, int cy) 
{
	CButton::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	CBitmap * pBitmap;
	switch(m_State)
	{
	case NFC_BUTTON_STATE_AUTO:
		pBitmap = &m_BitmapUp;
		break;
	case NFC_BUTTON_STATE_UP:
		pBitmap = &m_BitmapUp;
		break;
	case NFC_BUTTON_STATE_DOWN:
		pBitmap = &m_BitmapDown;
		break;
	default:
		ASSERT(FALSE);
	}

	if(pBitmap->GetSafeHandle())
	{
		CSize BitmapSize = pBitmap->GetBitmapDimension();
		if(BitmapSize.cx != cx || BitmapSize.cy != cy)
		{
			this->SetWindowPos(NULL, 0, 0, BitmapSize.cx, BitmapSize.cy, SWP_NOMOVE | SWP_NOZORDER);
		}
	}
}

void NFCButton::OnEnable(BOOL bEnable) 
{
	CButton::OnEnable(bEnable);
	
	// TODO: Add your message handler code here
	if(bEnable)
	{
		this->ShowWindow(SW_SHOW);
	}
	else
	{
		this->ShowWindow(SW_HIDE);
	}
}

void NFCButton::PreSubclassWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
    // Owner Draw Ӽ Ѵ.
    DWORD dwStyle = this->GetStyle();
    ::SetWindowLong(this->GetSafeHwnd(), GWL_STYLE, dwStyle | BS_OWNERDRAW);

	if(this->IsWindowEnabled() == FALSE)
	{
		this->ShowWindow(SW_HIDE);
	}
	
	CButton::PreSubclassWindow();
}
