// NFCEdit.cpp : implementation file
//

#include "stdafx.h"
//#include "	\ add additional includes here"
#include "NFCEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// NFCEdit

NFCEdit::NFCEdit()
{
	m_TextColor = RGB(0, 0, 0);
	m_BackgroundColor = RGB(255, 255, 255);
}

NFCEdit::~NFCEdit()
{
	if(m_Brush.GetSafeHandle())
	{
		m_Brush.DeleteObject();
	}

	if(m_Font.GetSafeHandle())
	{
		m_Font.DeleteObject();
	}
}


BEGIN_MESSAGE_MAP(NFCEdit, CEdit)
	//{{AFX_MSG_MAP(NFCEdit)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NFCEdit message handlers

HBRUSH NFCEdit::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	// TODO: Change any attributes of the DC here
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetBkColor(m_BackgroundColor); // ؽƮ 
	pDC->SetTextColor(m_TextColor);

	// TODO: Return a non-NULL brush if the parent's handler should not be called
	//return (HBRUSH)GetStockObject(NULL_BRUSH);
	return m_Brush;	// Ʈ 
	//return NULL;
}

void NFCEdit::SetTextColor(COLORREF i_Color)
{
	m_TextColor = i_Color;
}

void NFCEdit::SetBackgroundColor(COLORREF i_Color)
{
	m_BackgroundColor = i_Color;

	if(m_Brush.GetSafeHandle())
	{
		m_Brush.DeleteObject();
	}
	m_Brush.CreateSolidBrush(m_BackgroundColor);
}

void NFCEdit::OnSize(UINT nType, int cx, int cy) 
{
	CEdit::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	// Initializes a CFont object with the characteristics given 
	// in a LOGFONT structure.
	CFont * pFont;
	LOGFONT lf;

	pFont = this->GetFont();
	pFont->GetLogFont(&lf);
	//memset(&lf, 0, sizeof(LOGFONT));	// zero out structure
	lf.lfHeight = cy - 2;				// request a 12-pixel-height font
	//strcpy(lf.lfFaceName, "Arial");	// request a face name "Arial"

	if(m_Font.GetSafeHandle())
	{
		m_Font.DeleteObject();
	}

	VERIFY(m_Font.CreateFontIndirect(&lf));  // create the font

	this->SetFont(&m_Font);	
}
