// NFTrace.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "NFTrace.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifdef _DEBUG

static AFX_EXTENSION_MODULE NFTraceDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("NFTRACE.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(NFTraceDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(NFTraceDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("NFTRACE.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(NFTraceDLL);
	}
	return 1;   // ok
}

//////////////////////////////////////////////////////////////////////
// NFTrace Class
//////////////////////////////////////////////////////////////////////

DWORD NFTrace::m_Depth = 0;
CString NFTrace::m_File;
DWORD NFTrace::m_Line = 0;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

NFTrace::NFTrace()
{
	m_Title.Format("%s, line %d", m_File, m_Line);

	this->Trace(">>>>%s", m_Title);
	++m_Depth;
}

NFTrace::NFTrace(LPCTSTR i_Title)
{
	m_Title = i_Title;

	this->Trace(">>>>%s", m_Title);
	++m_Depth;
}

NFTrace::~NFTrace()
{
	//TRACE("m_Depth : %d", m_Depth);
	if(--m_Depth == 0)
	{
		//TRACE("m_File.Empty();");
		m_File.Empty();
	}

	this->Trace("<<<<%s", m_Title);
}

void NFTrace::SetFileLine(LPCTSTR i_File, DWORD i_Line)
{
	m_File = i_File;
	m_Line = i_Line;
}

void NFTrace::Trace(LPCTSTR lpszFormat, ...)
{
#ifdef _DEBUG // all AfxTrace output is controlled by afxTraceEnabled
	if (!afxTraceEnabled)
		return;
#endif

	ASSERT(AfxIsValidString(lpszFormat));

	va_list args;
	va_start(args, lpszFormat);

	CString stringBuffer;
	stringBuffer.FormatV(lpszFormat, args);

	va_end(args);

	for(DWORD i = 0; i < m_Depth; ++i)
	{
		stringBuffer = "\t" + stringBuffer;
	}
	stringBuffer += "\n";

	if ((afxTraceFlags & traceMultiApp) && (AfxGetApp() != NULL))
		afxDump << AfxGetApp()->m_pszExeName << ": ";
	afxDump << stringBuffer;
}

#endif // _DEBUG
