// NFTrace.h: interface for the NFTrace class.
//
//////////////////////////////////////////////////////////////////////

#ifdef _DEBUG

#if !defined(AFX_NFTRACE_H__00F22A24_0344_47AE_A7BD_D58BADC0C163__INCLUDED_)
#define AFX_NFTRACE_H__00F22A24_0344_47AE_A7BD_D58BADC0C163__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class AFX_EXT_CLASS NFTrace  
{
public: // Constructor & Destructor
	// It is recommended that you don't allocate this class dynamically
	NFTrace();
	NFTrace(LPCTSTR i_Title);
	virtual ~NFTrace();

public:
	static void SetFileLine(LPCTSTR i_File, DWORD i_Line);
	static void Trace(LPCTSTR lpszFormat, ...);

private:
	CString m_Title;
	static CString m_File;
	static DWORD m_Line;
	static DWORD m_Depth;
};

#define NFTRACE_USED NFTrace::SetFileLine(__FILE__, __LINE__); NFTrace NFTrace_Local_Instance
#define NFTRACE_ENTER NFTrace::SetFileLine(__FILE__, __LINE__); NFTrace NFTrace_Local_Instance
#define NFTRACE_EXIT (void) 0

#define NFTRACE NFTrace::Trace

#ifdef TRACE
#undef TRACE
#define TRACE NFTrace::Trace
#endif // TRACE

#endif // !defined(AFX_NFTRACE_H__00F22A24_0344_47AE_A7BD_D58BADC0C163__INCLUDED_)

#else // _DEBUG
#define NFTRACE_USED (void)0
#define NFTRACE_ENTER (void) 0
#define NFTRACE_EXIT (void) 0
#define NFTRACE (void)0
#endif // _DEBUG
